import React from 'react';

import Head from 'next/head';

import { Themes } from '@/meta/settings';

import Body from './Body';

interface Props {
  theme?: Themes
}

const Content: React.FC<Props & React.PropsWithChildren> = (props) => {

  const { theme, children } = props;

  return (
      <html data-theme={theme}>
        <Head>
          <meta charSet="utf-8" />
          <meta name="viewport" content="width=device-width, initial-scale=1" />
        </Head>
        <Body theme={theme}>{children}</Body>
      </html>
  );
};

export default Content;