import React from 'react';

import { cookies } from 'next/headers'

import WithRedux from '@/store/withRedux';
import Content from './Content';
import { DEFAULT_THEME, Themes } from '@/meta/settings';

const Layout: React.FC<React.PropsWithChildren> = (props) => {

  const { children } = props;

  const cookieStore = cookies()

  const theme = cookieStore.get('theme')

  return (
    <WithRedux>
      <Content theme={theme ? theme?.value as Themes : DEFAULT_THEME}>
        {children}
      </Content>
    </WithRedux>
  );
};

export default Layout;