import { YOUPORN_BASE_SEARCH, YOUPORN_BASE_URL } from "@/constants/urls"
import { getHeadersWithCookie } from "../common/headers"
import axios from "axios"
import { MindGeekVideoSrcElem, VideoSourceItem } from "@/meta/data"

export const getYouPornQueryUrl = async (query?: string): Promise<string> => {

    if (query) {
        return `${YOUPORN_BASE_SEARCH}${query}`
    }

    return YOUPORN_BASE_URL
}

export const getYouPornMediaUrlList = async (url: string, sessionCookie: string): Promise<VideoSourceItem[]> => {

    const headersWithCookie = getHeadersWithCookie(YOUPORN_BASE_URL, sessionCookie)

    let videos: VideoSourceItem[] = []

    await axios.get(url, headersWithCookie)
        .then(async response => {

            if (response.data) {

                videos = await response.data.map((elem: MindGeekVideoSrcElem) => ({
                    src: elem?.videoUrl,
                    type: 'video/mp4',
                    size: elem?.quality
                })) as VideoSourceItem[]

                return videos

            } else {
                return []
            }

        })
        .catch(error => console.log(error))

    return videos
}